// PaintST.cpp : implementation file
//

#include "stdafx.h"
#include "RGB Prev.h"
#include "PaintST.h"
#include "RGBDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPaintST

CPaintST::CPaintST(){ }

CPaintST::~CPaintST(){ }

BEGIN_MESSAGE_MAP(CPaintST, CStatic)
	//{{AFX_MSG_MAP(CPaintST)
	ON_WM_ERASEBKGND()
	ON_WM_PAINT()
	ON_WM_DESTROY()
	ON_WM_CTLCOLOR_REFLECT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPaintST message handlers

void CPaintST::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	CBrush*	pOldBrush;
	GetClientRect(rcStatic);

	CBrush	brBack(m_crBkColor);
	dc.FillRect(rcStatic, &brBack);
	pOldBrush = dc.SelectObject(&brBack);
	dc.SelectObject(pOldBrush);
	
		
	// Do not call CStatic::OnPaint() for painting messages
}

HBRUSH CPaintST::CtlColor(CDC* pDC, UINT nCtlColor) 
{
	ASSERT(nCtlColor == CTLCOLOR_STATIC);
    	
	return m_brBkgnd;
}

void CPaintST::SetBkColor(COLORREF crBkColor)
{
	// Set new color.
	if (crBkColor != 0xFFFFFFFF)
	{
		m_crBkColor = crBkColor;
	}
	else{
		m_crBkColor = ::GetSysColor(COLOR_BTNFACE);
	}
	m_brBkgnd.DeleteObject();
	m_brBkgnd.CreateSolidBrush(m_crBkColor);
	// Repaint to the background.
	Invalidate();

}

COLORREF CPaintST::GetBkColor() 
{ 
	return m_crBkColor; 
}

BOOL CPaintST::OnEraseBkgnd(CDC* pDC) 
{
	CBrush	brBackgnd;

	// Get a pointer to the parent window
	CRGBDlg* pColorDlg = (CRGBDlg*) GetParent();

// I am not sure to this statement.
#ifdef _DEBUG
	ASSERT_VALID(pColorDlg);
#else
	ASSERT(pColorDlg != NULL);	// Do I have a valid pointer? 
#endif

	// Get new color value from SliderCtrl.
	m_crBkColor = RGB ((BYTE) pColorDlg->nColor[0],
						(BYTE) pColorDlg->nColor[1],
						(BYTE) pColorDlg->nColor[2]);

	GetClientRect(rcStatic);
	brBackgnd.CreateSolidBrush(m_crBkColor);
	pDC->FillRect(rcStatic, &brBackgnd);
	
	return CStatic::OnEraseBkgnd(pDC);
}

void CPaintST::OnDestroy() 
{
	CStatic::OnDestroy();
	
	// Delete object to stored in memory.
	m_brBkgnd.DeleteObject();
}

